//Node mailer features
/*
   1 - A single module with zero dependencies – code is easily auditable, as there are no dark corners
   2 - Heavy focus on security, no-one likes RCE vulnerabilities
   3 - Unicode support to use any characters, including emoji 💪
   4 - Windows support – you can install it with npm on Windows just like any other module, there are no compiled dependencies. Use it hassle free from Azure or from your Windows box
   5 - Use HTML content, as well as plain text alternative
   6 - Add Attachments to messages
   7 - Embedded image attachments for HTML content – your design does not get blocked
   8 - Secure email delivery using TLS/STARTTLS
   9 - Different transport methods in addition to the built-in SMTP support
   10- Sign messages with DKIM
   11- Custom Plugin support for manipulating messages
   12- Sane OAuth2 authentication
   13- Proxies for SMTP connections
   14- ES6 code – no more unintentional memory leaks, due to hoisted var’s
   15- Autogenerated email test accounts from Ethereal.email
*/

const CONFIG = require('../config/' + process.env.NODE_ENV + '.js');
const nodemailer = require('nodemailer');

const EAdress = CONFIG.EAdress;
const EPassword = CONFIG.EPassword;

module.exports = {

    SendEmail: function (to_Array_Receiver, subject, html, callback) {
        if (EAdress == "" || EPassword == "") throw "SetSenderEmail"

        var transporter = this.Transporter();
        var objects = this.ContentEmail(to_Array_Receiver, subject, html);


        objects.forEach(function (elemet) {
            transporter.sendMail(elemet, function (err, info) {
                if (err) {
                    console.log(err);
                    callback({"text" : "email not send" , "status" : "no"});
                } else {
                    console.log(JSON.stringify(info));
                    callback({"text" : "email send currectly" , "status" : "ok"});
                }

            });
        })
    },

    Transporter: function () {
        var transporter = nodemailer.createTransport({
            service: 'gmail',
            auth: {
                user: EAdress,
                pass: EPassword
            }
        });
        return transporter;
    },

    ContentEmail: function (to, subject, html) {
        var objects = [];
        for (var i = 0; i < to.length; i++) {
            objects.push({
                from: EAdress,
                to: to[i],
                subject: subject,
                html: html
            })
        }
        return objects;
    },

    html: function (url) {
        return `
        <html lang="en">
            <head>
                <meta charset="UTF-8"><meta name="viewport" content="width=device-width, initial-scale=1.0">
            </head>
            <body>
                <div class="container" style="text-align: center">
                    <h1 style="color: goldenrod">UniCalender</h1>
                    <h3>برای تاید و فعال سازی حساب خود بر روی لینک زیر کلیک کنید</h3>
                    <p style="text-decoration: none; background-color: green;color: white;padding: 10px ;border-radius: 10px" href="#">
                    <a href=${url}>${url}</a></p>
                </div>
            </body>
        </html>`;
    },

    letter: function (title, content) {
        return `
        <html lang="en">
            <head>
                <meta charset="UTF-8"><meta name="viewport" content="width=device-width, initial-scale=1.0">
            </head>
            <body>
                <div class="container" style="text-align: center">
                    <h1 style="color: goldenrod">UniCalender</h1>
                    <h2 style="color: green">${title}</h2>
                    <p>${content}</p>
                </div>
            </body>
        </html>`;
    }
}